???File Path
==========
***...\Models\accounts\PaidchequeModels.cs


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@  ChequePrintSettings  @@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
public class MdlChequePrintSettings {

	public long binChequePrintSettingsId { get; set; } = 0;
	
	[Required(AllowEmptyStrings = false)]
	[DisplayFormat(ConvertEmptyStringToNull = false)]
	[StringLength(50)]
	[Display(Name = "Cheque Print Name")]
	public string strChequePrintName { get; set; } = "";
	
	public short sinPayeeNameLine1XCordinate { get; set; } = 0;
	public short sinPayeeNameLine2XCordinate { get; set; } = 0;
	public short sinDateXCordinate { get; set; } = 0;
	public short sinAmountXCordinate { get; set; } = 0;
	public short sinAmountInWordsLine1XCordinate { get; set; } = 0;
	public short sinAmountInWordsLine2XCordinate { get; set; } = 0;
	
	public short sinPayeeNameLine1YCordinate { get; set; } = 0;
	public short sinPayeeNameLine2YCordinate { get; set; } = 0;
	public short sinDateYCordinate { get; set; } = 0;
	public short sinAmountYCordinate { get; set; } = 0;
	public short sinAmountInWordsLine1YCordinate { get; set; } = 0;
	public short sinAmountInWordsLine2YCordinate { get; set; } = 0;
	
	public short sinPayeeNameLine1Characters { get; set; } = 0;
	public short sinPayeeNameLine2Characters { get; set; } = 0;
	public short sinDateCharacters { get; set; } = 0;
	public short sinAmountCharacters { get; set; } = 0;
	public short sinAmountInWordsLine1Characters { get; set; } = 0;
	public short sinAmountInWordsLine2Characters { get; set; } = 0;
	
	public short sinPayeeNameLine1FontSize { get; set; } = 0;
	public short sinPayeeNameLine2FontSize { get; set; } = 0;
	public short sinDateFontSize { get; set; } = 10;
	public short sinAmountFontSize { get; set; } = 10;
	public short sinAmountInWordsLine1FontSize { get; set; } = 0;
	public short sinAmountInWordsLine2FontSize { get; set; } = 0;
	
	public short sinPayeeNameLine1Bold { get; set; } = 0;
	public short sinPayeeNameLine2Bold { get; set; } = 0;
	public short sinDateBold { get; set; } = 0;
	public short sinAmountBold { get; set; } = 0;
	public short sinAmountInWordsLine1Bold { get; set; } = 0;
	public short sinAmountInWordsLine2Bold { get; set; } = 0;
	
	[StringLength(150)]
	public string strPayeeNameLine1Value { get; set; } = "";
	[StringLength(150)]
	public string strPayeeNameLine2Value { get; set; } = "";
	[StringLength(150)]
	public string strDateValue { get; set; } = "";
	[StringLength(150)]
	public string strAmountValue { get; set; } = "";
	[StringLength(150)]
	public string strAmountInWordsLine1Value { get; set; } = "";
	[StringLength(150)]
	public string strAmountInWordsLine2Value { get; set; } = "";
	
	public short sinAcPayXCordinate { get; set; } = 0;
	public short sinAcPayYCordinate { get; set; } = 0;
	[StringLength(150)]
	public string strAcPayValue { get; set; } = "";
	public short sinAcPayAngle { get; set; } = 0;
	public short sinAcPayFontSize { get; set; } = 10;
	public short sinAcPayBold { get; set; } = 0;
	
}

public class MdlReqChequePrintSettings : MdlRequest {

	public MdlChequePrintSettings mdlChequePrintSettings { get; set; } = new MdlChequePrintSettings();
}

public class MdlResChequePrintSettings : MdlResponse {

	public MdlChequePrintSettings mdlChequePrintSettings { get; set; } = new MdlChequePrintSettings();
}

public class MdlResChequePrintSettingsList : MdlResponse {

	public List<MdlChequePrintSettings> lstMdlChequePrintSettings { get; set; } = new List<MdlChequePrintSettings>();
}

public class MdlResChequePrintSettingsInit : MdlResponse {


	public List<MdlChequePrintSettings> lstMdlChequePrintSettings { get; set; } = new List<MdlChequePrintSettings>();
}

