???File Path
==========
***...\Src\Accounts\ChequePrintSettings.cs




???Check the points
==================



            // ??? IMPORT:- Add the items top - Duplcation Avoid
            using System;
            using System.Data;
            using System.Collections.Generic;
            using Npgsql;
            using NpgsqlTypes;

            using TAAS.Db;
            using TAAS.Models;
            using TAAS.Models.Accounts;
            using TAAS.Helpers;
        


            // ??? CLASS ATTRIBUTES:- The code past top of the class(Attributes) - Duplcation Avoid
            public GlobalFunctions insGlobalFunctions = new GlobalFunctions();
            DbService insDbService = new();
        


            public List<MdlBaseIntId> FnGetAllChequePrintSettingsBaseData()
            {
                List<MdlBaseIntId> lstMdlChequePrintSettingsBaseIntId = new List<MdlBaseIntId>();

                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_cheque_print_settings()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlBaseIntId mdlBaseIntId = new MdlBaseIntId();

                        mdlBaseIntId.binPkId = (DBNull.Value != objRecord["pk_cheque_print_settings_id"]) ? (long)Convert.ToUInt64(objRecord["pk_cheque_print_settings_id"]) : mdlBaseIntId.binPkId;
                        mdlBaseIntId.strCode = (DBNull.Value != objRecord[""]) ? Convert.ToString(objRecord[""]) : mdlBaseIntId.strCode;
                        mdlBaseIntId.strName = (DBNull.Value != objRecord["vhr_cheque_print_name"]) ? Convert.ToString(objRecord["vhr_cheque_print_name"]) : mdlBaseIntId.strName;
        
                        lstMdlChequePrintSettingsBaseIntId.Add(mdlBaseIntId);
                    }
                }

                return lstMdlChequePrintSettingsBaseIntId;
            }
        


            public List<MdlChequePrintSettings> FnGetAllChequePrintSettingsWithActionUser()
            {
                List<MdlChequePrintSettings> lstMdlChequePrintSettings = new List<MdlChequePrintSettings>();
                
                // Get Data from DB
                DataSet objDataSet = this.insDbService.FnExcecuteSqlCommand("SELECT * FROM fn_get_all_cheque_print_settings_with_action_user()");
                if (objDataSet != null)
                {
                    foreach (DataRow objRecord in objDataSet.Tables[0].Rows)
                    {
                        MdlChequePrintSettings mdlChequePrintSettings = new MdlChequePrintSettings();

                        
				mdlChequePrintSettings.binChequePrintSettingsId = (DBNull.Value != objRecord["pk_cheque_print_settings_id"]) ? (long)Convert.ToInt64(objRecord["pk_cheque_print_settings_id"]) : mdlChequePrintSettings.binChequePrintSettingsId;

				mdlChequePrintSettings.strChequePrintName = (DBNull.Value != objRecord["vhr_cheque_print_name"]) ? Convert.ToString(objRecord["vhr_cheque_print_name"]) : mdlChequePrintSettings.strChequePrintName;

				mdlChequePrintSettings.sinPayeeNameLine1XCordinate = (DBNull.Value != objRecord["sin_payee_name_line1_x_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line1_x_cordinate"]) : mdlChequePrintSettings.sinPayeeNameLine1XCordinate;
				mdlChequePrintSettings.sinPayeeNameLine2XCordinate = (DBNull.Value != objRecord["sin_payee_name_line2_x_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line2_x_cordinate"]) : mdlChequePrintSettings.sinPayeeNameLine2XCordinate;
				mdlChequePrintSettings.sinDateXCordinate = (DBNull.Value != objRecord["sin_date_x_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_date_x_cordinate"]) : mdlChequePrintSettings.sinDateXCordinate;
				mdlChequePrintSettings.sinAmountXCordinate = (DBNull.Value != objRecord["sin_amount_x_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_amount_x_cordinate"]) : mdlChequePrintSettings.sinAmountXCordinate;
				mdlChequePrintSettings.sinAmountInWordsLine1XCordinate = (DBNull.Value != objRecord["sin_amount_in_words_line1_x_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line1_x_cordinate"]) : mdlChequePrintSettings.sinAmountInWordsLine1XCordinate;
				mdlChequePrintSettings.sinAmountInWordsLine2XCordinate = (DBNull.Value != objRecord["sin_amount_in_words_line2_x_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line2_x_cordinate"]) : mdlChequePrintSettings.sinAmountInWordsLine2XCordinate;

				mdlChequePrintSettings.sinPayeeNameLine1YCordinate = (DBNull.Value != objRecord["sin_payee_name_line1_y_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line1_y_cordinate"]) : mdlChequePrintSettings.sinPayeeNameLine1YCordinate;
				mdlChequePrintSettings.sinPayeeNameLine2YCordinate = (DBNull.Value != objRecord["sin_payee_name_line2_y_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line2_y_cordinate"]) : mdlChequePrintSettings.sinPayeeNameLine2YCordinate;
				mdlChequePrintSettings.sinDateYCordinate = (DBNull.Value != objRecord["sin_date_y_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_date_y_cordinate"]) : mdlChequePrintSettings.sinDateYCordinate;
				mdlChequePrintSettings.sinAmountYCordinate = (DBNull.Value != objRecord["sin_amount_y_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_amount_y_cordinate"]) : mdlChequePrintSettings.sinAmountYCordinate;
				mdlChequePrintSettings.sinAmountInWordsLine1YCordinate = (DBNull.Value != objRecord["sin_amount_in_words_line1_y_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line1_y_cordinate"]) : mdlChequePrintSettings.sinAmountInWordsLine1YCordinate;
				mdlChequePrintSettings.sinAmountInWordsLine2YCordinate = (DBNull.Value != objRecord["sin_amount_in_words_line2_y_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line2_y_cordinate"]) : mdlChequePrintSettings.sinAmountInWordsLine2YCordinate;

				mdlChequePrintSettings.sinPayeeNameLine1Characters = (DBNull.Value != objRecord["sin_payee_name_line1_characters"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line1_characters"]) : mdlChequePrintSettings.sinPayeeNameLine1Characters;
				mdlChequePrintSettings.sinPayeeNameLine2Characters = (DBNull.Value != objRecord["sin_payee_name_line2_characters"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line2_characters"]) : mdlChequePrintSettings.sinPayeeNameLine2Characters;
				mdlChequePrintSettings.sinDateCharacters = (DBNull.Value != objRecord["sin_date_characters"]) ? (short)Convert.ToInt16(objRecord["sin_date_characters"]) : mdlChequePrintSettings.sinDateCharacters;
				mdlChequePrintSettings.sinAmountCharacters = (DBNull.Value != objRecord["sin_amount_characters"]) ? (short)Convert.ToInt16(objRecord["sin_amount_characters"]) : mdlChequePrintSettings.sinAmountCharacters;
				mdlChequePrintSettings.sinAmountInWordsLine1Characters = (DBNull.Value != objRecord["sin_amount_in_words_line1_characters"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line1_characters"]) : mdlChequePrintSettings.sinAmountInWordsLine1Characters;
				mdlChequePrintSettings.sinAmountInWordsLine2Characters = (DBNull.Value != objRecord["sin_amount_in_words_line2_characters"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line2_characters"]) : mdlChequePrintSettings.sinAmountInWordsLine2Characters;

				mdlChequePrintSettings.sinPayeeNameLine1FontSize = (DBNull.Value != objRecord["sin_payee_name_line1_font_size"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line1_font_size"]) : mdlChequePrintSettings.sinPayeeNameLine1FontSize;
				mdlChequePrintSettings.sinPayeeNameLine2FontSize = (DBNull.Value != objRecord["sin_payee_name_line2_font_size"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line2_font_size"]) : mdlChequePrintSettings.sinPayeeNameLine2FontSize;
				mdlChequePrintSettings.sinDateFontSize = (DBNull.Value != objRecord["sin_date_font_size"]) ? (short)Convert.ToInt16(objRecord["sin_date_font_size"]) : mdlChequePrintSettings.sinDateFontSize;
				mdlChequePrintSettings.sinAmountFontSize = (DBNull.Value != objRecord["sin_amount_font_size"]) ? (short)Convert.ToInt16(objRecord["sin_amount_font_size"]) : mdlChequePrintSettings.sinAmountFontSize;
				mdlChequePrintSettings.sinAmountInWordsLine1FontSize = (DBNull.Value != objRecord["sin_amount_in_words_line1_font_size"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line1_font_size"]) : mdlChequePrintSettings.sinAmountInWordsLine1FontSize;
				mdlChequePrintSettings.sinAmountInWordsLine2FontSize = (DBNull.Value != objRecord["sin_amount_in_words_line2_font_size"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line2_font_size"]) : mdlChequePrintSettings.sinAmountInWordsLine2FontSize;

				mdlChequePrintSettings.sinPayeeNameLine1Bold = (DBNull.Value != objRecord["sin_payee_name_line1_bold"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line1_bold"]) : mdlChequePrintSettings.sinPayeeNameLine1Bold;
				mdlChequePrintSettings.sinPayeeNameLine2Bold = (DBNull.Value != objRecord["sin_payee_name_line2_bold"]) ? (short)Convert.ToInt16(objRecord["sin_payee_name_line2_bold"]) : mdlChequePrintSettings.sinPayeeNameLine2Bold;
				mdlChequePrintSettings.sinDateBold = (DBNull.Value != objRecord["sin_date_bold"]) ? (short)Convert.ToInt16(objRecord["sin_date_bold"]) : mdlChequePrintSettings.sinDateBold;
				mdlChequePrintSettings.sinAmountBold = (DBNull.Value != objRecord["sin_amount_bold"]) ? (short)Convert.ToInt16(objRecord["sin_amount_bold"]) : mdlChequePrintSettings.sinAmountBold;
				mdlChequePrintSettings.sinAmountInWordsLine1Bold = (DBNull.Value != objRecord["sin_amount_in_words_line1_bold"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line1_bold"]) : mdlChequePrintSettings.sinAmountInWordsLine1Bold;
				mdlChequePrintSettings.sinAmountInWordsLine2Bold = (DBNull.Value != objRecord["sin_amount_in_words_line2_bold"]) ? (short)Convert.ToInt16(objRecord["sin_amount_in_words_line2_bold"]) : mdlChequePrintSettings.sinAmountInWordsLine2Bold;

				mdlChequePrintSettings.strPayeeNameLine1Value = (DBNull.Value != objRecord["vhr_payee_name_line1_value"]) ? Convert.ToString(objRecord["vhr_payee_name_line1_value"]) : mdlChequePrintSettings.strPayeeNameLine1Value;
				mdlChequePrintSettings.strPayeeNameLine2Value = (DBNull.Value != objRecord["vhr_payee_name_line2_value"]) ? Convert.ToString(objRecord["vhr_payee_name_line2_value"]) : mdlChequePrintSettings.strPayeeNameLine2Value;
				mdlChequePrintSettings.strDateValue = (DBNull.Value != objRecord["vhr_date_value"]) ? Convert.ToString(objRecord["vhr_date_value"]) : mdlChequePrintSettings.strDateValue;
				mdlChequePrintSettings.strAmountValue = (DBNull.Value != objRecord["vhr_amount_value"]) ? Convert.ToString(objRecord["vhr_amount_value"]) : mdlChequePrintSettings.strAmountValue;
				mdlChequePrintSettings.strAmountInWordsLine1Value = (DBNull.Value != objRecord["vhr_amount_in_words_line1_value"]) ? Convert.ToString(objRecord["vhr_amount_in_words_line1_value"]) : mdlChequePrintSettings.strAmountInWordsLine1Value;
				mdlChequePrintSettings.strAmountInWordsLine2Value = (DBNull.Value != objRecord["vhr_amount_in_words_line2_value"]) ? Convert.ToString(objRecord["vhr_amount_in_words_line2_value"]) : mdlChequePrintSettings.strAmountInWordsLine2Value;

				mdlChequePrintSettings.sinAcPayXCordinate = (DBNull.Value != objRecord["sin_ac_pay_x_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_ac_pay_x_cordinate"]) : mdlChequePrintSettings.sinAcPayXCordinate;
				mdlChequePrintSettings.sinAcPayYCordinate = (DBNull.Value != objRecord["sin_ac_pay_y_cordinate"]) ? (short)Convert.ToInt16(objRecord["sin_ac_pay_y_cordinate"]) : mdlChequePrintSettings.sinAcPayYCordinate;
				mdlChequePrintSettings.strAcPayValue = (DBNull.Value != objRecord["vhr_ac_pay_value"]) ? Convert.ToString(objRecord["vhr_ac_pay_value"]) : mdlChequePrintSettings.strAcPayValue;
				mdlChequePrintSettings.sinAcPayAngle = (DBNull.Value != objRecord["sin_ac_pay_angle"]) ? (short)Convert.ToInt16(objRecord["sin_ac_pay_angle"]) : mdlChequePrintSettings.sinAcPayAngle;
				mdlChequePrintSettings.sinAcPayFontSize = (DBNull.Value != objRecord["sin_ac_pay_font_size"]) ? (short)Convert.ToInt16(objRecord["sin_ac_pay_font_size"]) : mdlChequePrintSettings.sinAcPayFontSize;
				mdlChequePrintSettings.sinAcPayBold = (DBNull.Value != objRecord["sin_ac_pay_bold"]) ? (short)Convert.ToInt16(objRecord["sin_ac_pay_bold"]) : mdlChequePrintSettings.sinAcPayBold;


        
                        lstMdlChequePrintSettings.Add(mdlChequePrintSettings);
                    }
                }

                return lstMdlChequePrintSettings;
            }
        


            public MdlResChequePrintSettings FnInsertOrUpdateChequePrintSettings(MdlReqChequePrintSettings mdlReqChequePrintSettings)
            {
                // *** Input Validation INSERT and UPDATE Case[not duplicate model validation]
                // ??? Duplication Checking in DB FUCTION(Insert and Update) - CODE, NAME [, other unique fields] Already exists
                // ??? Count Exced or other checking License related in DB FUCTION(Insert)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)

                // Set Create or modified User in DB FUCTION(Insert, Update and Delete)
                if (mdlReqChequePrintSettings.mdlChequePrintSettings.binChequePrintSettingsId == 0)
                {
                    mdlReqChequePrintSettings.mdlChequePrintSettings.intSysActionId = 0;
                    mdlReqChequePrintSettings.mdlChequePrintSettings.binCreatedUserId = mdlReqChequePrintSettings.linLoginUserId;
                    mdlReqChequePrintSettings.mdlChequePrintSettings.strCreatedUser = mdlReqChequePrintSettings.strLoginUserName;
                    mdlReqChequePrintSettings.mdlChequePrintSettings.dtmCreated = mdlReqChequePrintSettings.dtmCurrentDateTime;
                }
                else {
                    mdlReqChequePrintSettings.mdlChequePrintSettings.binLastModifiedUserId = mdlReqChequePrintSettings.linLoginUserId;
                    mdlReqChequePrintSettings.mdlChequePrintSettings.strLastModifiedUser = mdlReqChequePrintSettings.strLoginUserName;
                    mdlReqChequePrintSettings.mdlChequePrintSettings.dtmLastModified = mdlReqChequePrintSettings.dtmCurrentDateTime;
                }

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("mdlChequePrintSettings", NpgsqlDbType.Jsonb) { Value = mdlReqChequePrintSettings.mdlChequePrintSettings, DataTypeName = "jsnChequePrintSettings"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_insert_or_update_chequePrintSettings(:mdlChequePrintSettings, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CHEQUEPRINTSETTINGS.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CHEQUEPRINTSETTINGS.CS#002", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CHEQUEPRINTSETTINGS.CS#003", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Saved
                MdlResChequePrintSettings mdlResChequePrintSettings = new MdlResChequePrintSettings();
                mdlResChequePrintSettings.mdlChequePrintSettings = mdlChequePrintSettingsReq.mdlChequePrintSettings;
                if (mdlReqChequePrintSettings.mdlChequePrintSettings.binChequePrintSettingsId == 0)
                {
                    mdlResChequePrintSettings.mdlChequePrintSettings.binChequePrintSettingsId = mdlDbResponse.binSqlPk ?? 0;
                    mdlResChequePrintSettings.mdlChequePrintSettings.dtmCreated = mdlDbResponse.dtmCurrent;
                }
                else
                {
                    mdlResChequePrintSettings.mdlChequePrintSettings.intSysActionId += 1;
                    mdlResChequePrintSettings.mdlChequePrintSettings.dtmLastModified = mdlDbResponse.dtmCurrent;
                }
                mdlResChequePrintSettings.sinStatus = 1;
                mdlResChequePrintSettings.strStatusCode = "SUCCESS";
                mdlResChequePrintSettings.strMessage = "CHEQUEPRINTSETTINGS has been Saved.";
                
                return mdlResChequePrintSettings;
            } 
        


            public MdlResBaseIntId FnDeleteChequePrintSettings(MdlReqBaseIntId mdlReqChequePrintSettingsBaseIntId)
            {
                // *** Input Validation DELETE Case[not duplicate model validation]
                // ??? FOREIGN KEY REFERENCES Ching in DB FUCTION(Delete)
                // ??? UPDATE Check already update another users in DB FUCTION(Update and Delete)
                // ??? Set Create or modified User in DB FUCTION(Insert, Update and Delete)

                // DB Actions
                NpgsqlParameter[] lstSqlParameter = {
                    new NpgsqlParameter("binChequePrintSettingsId", NpgsqlDbType.Bigint) { Value = mdlReqChequePrintSettingsBaseIntId.mdlBaseIntId.binPkId, DataTypeName = "binChequePrintSettingsId"},
                    new NpgsqlParameter("intSysActionId", NpgsqlDbType.Integer) { Value = mdlReqChequePrintSettingsBaseIntId.mdlBaseIntId.binCustomValue, DataTypeName = "intSysActionId"},
                    new NpgsqlParameter("binDeletedUserId", NpgsqlDbType.Bigint) { Value = mdlReqChequePrintSettingsBaseIntId.linLoginUserId, DataTypeName = "binDeletedUserId"},
                    new NpgsqlParameter("jsnSqlRes", NpgsqlDbType.Json) { DataTypeName = "jsnSqlRes", Direction = ParameterDirection.Output }
                };
                MdlDbResponse mdlDbResponse = this.insDbService.FnExcecuteOutSqlCommand("CALL sp_delete_chequePrintSettings(:binChequePrintSettingsId, :intSysActionId, :binDeletedUserId, NULL)", lstSqlParameter);
                // DB Error
                if (mdlDbResponse.sinSqlCustomStatus != 1)
                {
                    if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CHEQUEPRINTSETTINGS.CS#004", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_VALIDATION_ERROR")
                    {
                        throw (new TaasDatabaseValidationException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CHEQUEPRINTSETTINGS.CS#005", mdlDbResponse.strSqlSysMessage)));
                    }
                    else if (mdlDbResponse.strSqlCustomErrorType == "DATABASE_SYSTEM_ERROR")
                    {
                        throw (new TaasDatabaseException(this.insGlobalFunctions.FnGetExceptionResponseString(mdlDbResponse.strSqlCustomMessage, "CHEQUEPRINTSETTINGS.CS#006", mdlDbResponse.strSqlSysMessage)));
                    }
                }

                // Deleted
                MdlResBaseIntId mdlResChequePrintSettingsIntId = new MdlResBaseIntId();

                mdlResChequePrintSettingsIntId.mdlBaseIntId = mdlReqChequePrintSettingsBaseIntId.mdlBaseIntId;
                mdlResChequePrintSettingsIntId.sinStatus = 1;
                mdlResChequePrintSettingsIntId.strStatusCode = "SUCCESS";
                mdlResChequePrintSettingsIntId.strMessage = "CHEQUEPRINTSETTINGS has been deleted.";

                return mdlResChequePrintSettingsIntId;
            }
        

